config/routes.rb
Rails.application.routes.draw do

  match 'registration/start', via: [:get, :post, :put]
  match 'registration/register', via: [:get, :post]
  match 'registration/wei_register', via: [:get, :post]
  get 'registration/questions'
  post 'registration/pay'
  match 'registration/card', via: [:get, :post]
  get 'registration/details'

  ActiveAdmin.routes(self)

  resources :students do
    member do
      patch :card
    end
    resources :memberships, only: [:index]
    resources :payments, only: [:create, :update, :index]
  end

  resources :payments, only: [:index, :logs]
  get 'payments/logs', controller: 'payments', action: 'logs', as: :logs
  get 'payments/stats', controller: 'payments', action: 'stats', as: :trezo_stats

  scope 'wei' do
    resources :wei_registrations do
      member do
        post 'pay', as: :pay
      end
      collection do
        get 'waiting'
        get 'deposit'
        get 'registered'
        get 'unregistered'
        get 'to_refund'
        get 'parental'
      end
    end
    resources :wei_bungalows
    resources :wei_buses
  end

  get 'email/:key' => 'email#show', as: :view_email
  get 'email' => 'email#show' unless Rails.env.production?

  devise_for :users, :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }

  namespace :api, default: {format: :json}, path: '/api' do
    scope module: :version1 do
      match '*path', :controller => 'api', :action => 'cors', via: [:options]
      get 'auth' => 'api#auth'
      get 'membership' => 'membership#show'
      get 'students' => 'membership#index'
      get 'mass_students' => 'membership#bulk'
    end
  end

  root 'students#index'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/student.rb
class Student < ApplicationRecord

  belongs_to :study_year
  belongs_to :department
  has_many :payments
  has_many :paid_payments, -> { not_refunded }, class_name: 'Payment'
  has_many :memberships, through: :paid_payments, source: :payable, source_type: 'Membership'
  has_many :active_memberships, -> { active }, through: :paid_payments, source: :payable, source_type: 'Membership', class_name: 'Membership'
  has_many :weis, through: :paid_payments, source: :payable, source_type: 'Wei'
  has_many :wei_registrations
  has_many :cards

  scope :members, -> { joins(:memberships).where('memberships.start_date <= ? AND memberships.end_date >= ?', Date.today, Date.today) }
  scope :non_members, -> { where.not(id: members) }

  validates_presence_of :first_name, :last_name, :gender, :email, :birthday
  validates_uniqueness_of :student_id, if: -> (student) { not student.student_id.nil? and not student.student_id.empty? }
  validates_inclusion_of :gender, in: %w(M W)

  phony_normalize :phone, default_country_code: 'FR'
  validates_plausible_phone :phone, default_country_code: 'FR'

  scope :minors, -> { where('birthday > ?', 18.years.ago) }

  def card
    card = cards.order(:created_at).last
    if card.nil?
      ''
    else
      card.code
    end
  end

  def card=(card)
    if card.class == Card
      cards << card unless cards.include? card
    else
      c = cards.find_by_code card
      if c and c.student.id == id
        c.update! created_at: Time.now
      else
        cards.create! code: card
      end
    end
  end

  def minor?
    birthday > 18.years.ago
  end

  def member?
    active_memberships.length > 0
  end

  def available_memberships
    if member?
      Membership.where 'id < ?', 0
    else
      Membership.where('end_date > ?', Date.today).where.not(id: memberships)
    end
  end

  scope :search_with, -> (query) do
    request = all
    query.to_s.downcase.split(' ').each do |q|
      e = "%#{I18n.transliterate(q)}%"
      r = %w(first_name last_name).map {|f|"translate(LOWER(students.#{f}),'¹²³áàâãäåāăąÀÁÂÃÄÅĀĂĄÆćčç©ĆČÇĐÐèéêёëēĕėęěÈÊËЁĒĔĖĘĚ€ğĞıìíîïìĩīĭÌÍÎÏЇÌĨĪĬłŁńňñŃŇÑòóôõöōŏőøÒÓÔÕÖŌŎŐØŒř®ŘšşșßŠŞȘùúûüũūŭůÙÚÛÜŨŪŬŮýÿÝŸžżźŽŻŹ','123aaaaaaaaaaaaaaaaaaacccccccddeeeeeeeeeeeeeeeeeeeeggiiiiiiiiiiiiiiiiiillnnnnnnooooooooooooooooooorrrsssssssuuuuuuuuuuuuuuuuyyyyzzzzzz') LIKE ?"} .join ' OR '
      request = request.where(
          "#{r} OR students.student_id LIKE ? OR students.email LIKE ?",
          e,e,e,q
      )
    end
    request
  end

  def wei_registration
    wei_registrations.where(wei: Wei.current)
  end

  def name
    "#{first_name.capitalize} #{last_name.upcase}"
  end

end

app/controllers/students_controller.rb
class StudentsController < ApplicationController

  before_action :authenticate_user!
  before_action :set_student, only: [:show, :edit, :update, :destroy, :card]

  # GET /students
  # GET /students.json
  def index
    if params[:search].present?
      @students = Student.search_with(params[:search]).includes(:department, :study_year, :active_memberships)
    else
      @students = []
    end
  end

  # GET /students/1
  # GET /students/1.json
  def show
  end

  # GET /students/new
  def new
    @student = Student.new birthday: 18.years.ago
  end

  # GET /students/1/edit
  def edit
  end

  # POST /students
  # POST /students.json
  def create
    @student = Student.new(student_params)

    respond_to do |format|
      if @student.save
        format.html { redirect_to @student, notice: 'Student was successfully created.' }
        format.json { render :show, status: :created, location: @student }
      else
        format.html { render :new }
        format.json { render json: @student.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /students/1
  # PATCH/PUT /students/1.json
  def update
    respond_to do |format|
      if @student.update(student_params)
        format.html { redirect_to @student, notice: 'Student was successfully updated.' }
        format.json { render :show, status: :ok, location: @student }
      else
        format.html { render :edit }
        format.json { render json: @student.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /students/1
  # DELETE /students/1.json
  def destroy
    @student.destroy
    respond_to do |format|
      format.html { redirect_to students_url, notice: 'Student was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  def card
    begin
      @student.update(params.require(:student).permit(:card))
      @success = true
    rescue => _
      @success = false
    end
    respond_to do |format|
      format.js {}
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_student
      @student = Student.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def student_params
      params.require(:student).permit(:gender, :first_name, :last_name, :email, :card, :student_id, :department_id, :study_year_id, :phone, :birthday, :details)
    end
end

app/helpers/students_helper.rb
module StudentsHelper
end

app/views/students/_form.html.haml
= form_for(student) do |f|
  .row
    .col-md-2{class: [bs_form_error_cl(f,:gender)]}
      .form-group
        = f.label :gender
        = f.select :gender, [%w(Homme M), %w(Femme W)], {}, {class: 'form-control'}
    .col-md-5{class: [bs_form_error_cl(f,:first_name)]}
      .form-group
        = f.label :first_name
        = f.text_field :first_name, class: 'form-control'
        = bs_form_errors(f, :first_name)
    .col-md-5{class: [bs_form_error_cl(f,:last_name)]}
      .form-group
        = f.label :last_name
        = f.text_field :last_name, class: 'form-control'
        = bs_form_errors(f, :last_name)
  .row
    .col-lg-6
      .form-group{class: [bs_form_error_cl(f,:email)]}
        = f.label :email
        .input-group
          .text-warning= f.email_field :email, class: 'form-control'
          .input-group-btn
            %button#mail-insa.btn.btn-danger{type: :button, style: 'width:100px'}
              %span.d-inline.fa.fa-envelope
              %span.d-inline INSA
        = bs_form_errors(f, :email)
      .form-group{class: [bs_form_error_cl(f,:phone)]}
        = f.label :phone
        .text-warning= f.text_field :phone, class: 'form-control'
        = bs_form_errors(f, :phone)
      .form-group.row{class: [bs_form_error_cl(f,:birthday)]}
        .col-xs-12
          = f.label :birthday
        .col-xs-12.date
          = f.date_select :birthday, {end_year: 14.years.ago.year, start_year: 100.years.ago.year, with_css_classes:true}, class: 'form-control'
        .col-xs-12= bs_form_errors(f, :birthday)
    .col-lg-6
      .form-group{class: [bs_form_error_cl(f,:student_id)]}
        = f.label :student_id
        = f.text_field :student_id, class: 'form-control'
        = bs_form_errors(f, :student_id)
      .form-group{class: [bs_form_error_cl(f,:study_year_id)]}
        .text-warning= f.label :study_year_id
        = f.select :study_year_id, StudyYear.order(:year).map {|d|[d.name, d.id]}, {}, class: 'form-control'
        = bs_form_errors(f, :study_year_id)
      .form-group{class: [bs_form_error_cl(f,:department_id)]}
        .text-warning= f.label :department_id
        = f.select :department_id, Department.active.map {|d|[d.name, d.id]}, {}, {class: 'form-control'}
        = bs_form_errors(f, :department_id)


  .form-group
    = f.label :details
    = f.text_area :details, class: 'form-control'
  .actions
    = f.submit class:'btn btn-block btn-primary'

app/views/students/_memberships_card.html.haml
.card
  .card-header
    %h4.card-title= t('students.memberships')
  .list-group.m-a-1
    - student.paid_payments.order(:created_at).where(payable_type: 'Membership').each do |payment|
      .list-group-item.payment{data: {id: payment.id}}
        .list-group-item-text= payment.payable.name
        %p
          %span= payment.payable.start_date
          %span -
          %span= payment.payable.end_date
        - if (current_user.has_role? 'admin' and payment.payable.end_date > Date.today) or (payment.created_at > 12.hours.ago and not current_user.has_role? 'cdp')
          = form_for [payment.student, payment], remote: true do |f|
            = f.hidden_field :refunded, value: true
            = f.submit t('membership.refund'), class: 'btn btn-outline-danger btn-block', data: {confirm: t('are_you_sure')}
    - if student.memberships.count <= 0
      .list-group-item
        = t('students.has_no_memberships')
  - if student.available_memberships.length > 0
    .card-block
      %h4=t('.add_membership')
      = form_for [student, student.payments.build], remote:true do |f|
        .form-group
          %label=t('membership.membership')
          = f.collection_select :payable_id, student.available_memberships, :to_sgid, :name_with_price, {}, class: 'form-control'
        .form-group
          %label=t('membership.payment_method')
          = f.collection_select :payment_method_id, PaymentMethod.all, :id, :name, {}, class: 'form-control'
        = f.hidden_field :student_id, value: student.id
        = f.submit t('membership.register'), class: 'btn btn-primary btn-block'

app/views/students/_payments.html.haml
.card
  .card-block
    %h4.card-title= t('.payments')

  %table.table.table-striped.table-bordered
    %thead
      %tr
        %th= t('.payment_id')
        %th= t('.payment_type')
        %th= t('.payment_method')
        %th= t('.payment_price')
        %th= t('.payment_date')
        %th= t('.payment_refunded')
        %th= t('.payment_actions')
    %tbody
      - student.payments.each do |payment|
        %tr
          %td= payment.id
          %td= payment.payable.name
          %td= payment.payment_method.name
          %td= number_to_currency(payment.payable.price, locale: :fr)
          %td= payment.created_at
          %td
            - if payment.refunded
              = t('yes')
          %td
            -#- unless payment.refunded
            -#  = link_to t('membership.refund'), controller: :students, action: :show, params: {id:payment.id}

app/views/students/_refresh_student.js.erb
$('#memberships_card').html("<%= escape_javascript(render('students/memberships_card', student: student)) %>");
$('#student_card').html("<%= escape_javascript(render('students/student_card', student: student)) %>");
$('#student_va_card').html("<%= escape_javascript(render('students/student_va_card', student: student)) %>");

app/views/students/_student_card.html.haml
.card
  .card-block
    %h4.card-title
      %span.ajax.first_name.text-capitalize= student.first_name
      %span.ajax.last_name.text-uppercase= student.last_name
    - if student.department || student.study_year
      %div
        - if student.department
          %span= student.department.name
        - if student.department && student.study_year
          %span -
        - if student.study_year
          %span= student.study_year.name
  .list-group.list-group-flush
    - if student.member?
      .list-group-item.list-group-item-success
        .fa.fa-check
        = t('students.show.is_member')
    - else
      .list-group-item.list-group-item-danger
        .fa.fa-exclamation-triangle
        = t('students.show.is_not_member')
    - if student.card.empty?
      .list-group-item.list-group-item-warning
        .fa.fa-exclamation-triangle
        = t('students.show.no_card')
    - else
      .list-group-item
        .fa.fa-credit-card
        = student.card
    - unless student.student_id.empty?
      .list-group-item
        .fa.fa-user
        = student.student_id
    - unless student.email.empty?
      = mail_to student.email, class: 'list-group-item list-group-item-action' do
        .fa.fa-envelope
        = student.email
    .list-group-item{class: ('list-group-item-danger' if student.minor?)}
      .fa.fa-calendar
      = l student.birthday, format: :long
    - unless student.phone.empty?
      = link_to "tel:#{student.phone}", class: 'list-group-item list-group-item-action' do
        .fa.fa-phone
        = student.phone.phony_formatted(format: :international, space: '-')
    - unless student.details.empty?
      .list-group-item
        = student.details
  .card-block
    = link_to t('students.show.edit'), edit_student_path(student), class: %w(btn btn-primary pull-xs-right), target: ('_blank' if defined?(blank_wated_for_edit) and blank_wated_for_edit)

app/views/students/_student_va_card.html.haml
.card
  .card-header
    = t('.va_card')
  .card-block
    = form_for student, url: {action: :card, controller: :students, id: student.id}, remote: true do |f|
      .row
        .col-md-12{class: [bs_form_error_cl(f,:card)]}
          .form-group
            = f.text_field :card, class: 'form-control', placeholder: "N'a pas encore eu sa carte VA"
            = bs_form_errors(f, :card)
      .row{style: 'display: none'}
        .col-md-12
          = f.submit t('.edit_card'), class: 'btn btn-warning btn-block'

app/views/students/_students.html.haml
.list-group
  - students.each do |student|
    = link_to student_url(student), class: ['list-group-item', ('list-group-item-danger' unless student.member?)] do
      %span.first_name.text-capitalize= student.first_name
      %span.last_name.text-uppercase= student.last_name
      - if student.study_year
        %span.m-l-1.tag.tag-default.tag-pill.pull-xs-right= student.study_year.name
      - if student.department
        %span.m-l-1.tag.tag-default.tag-pill.pull-xs-right= student.department.code
  %span#fetching.list-group-item
    = t('students.fetching')

.list-group
  = link_to new_student_url, class: 'list-group-item list-group-item-action list-group-item-success' do
    .fa.fa-plus
    = t('students.new_student')

app/views/students/_wei_registration.html.haml
.card
  .card-header
    %h4.card-title= t('students.wei_registration')
  .list-group.m-a-1
    = link_to t('students.see_more'), student.wei_registrations.last, class: %w(btn btn-primary btn-block)

app/views/students/card.js.erb
<% if @success %>
  <%= render 'refresh_student', student: @student  %>
  alert("Carte VA enregistrée !");
<% else %>
  alert("Impossible d'enregistrer cette carte VA, elle est déjà utilisée !");
<% end %>

app/views/students/edit.html.erb
<h1>Editing Student</h1>

<%= render 'form', student: @student %>

<%= link_to 'Show', @student %> |
<%= link_to 'Back', students_path %>

app/views/students/index.html.erb
<h1 class="display-4 text-center m-b-2"><%= t('.memberslist') %></h1>

<%= form_tag students_url, method: :get, remote: true, id: 'students_search_form' do %>
    <%= text_field_tag :search, params[:search], placeholder: t('.search'), class: 'form-control', id: 'students_search' %>
<% end %>

<div id="students" class="m-t-2">
  <%= render 'students', students: @students %>
</div>

app/views/students/index.js.erb
$('#students').html("<%= escape_javascript(render('students/students', students: @students)) %>");

app/views/students/new.html.erb
<h1><%= t('.add_student') %></h1>

<%= render 'form', student: @student %>

<%= link_to 'Back', students_path %>

app/views/students/show.html.haml
.row
  #student_card.col-md-8
    = render 'student_card', student: @student
    - if current_user.has_role? :trezo
      = render 'payments', student: @student
  .col-md-4
    #memberships_card= render 'memberships_card', student: @student
    #student_va_card.m-t-1= render 'student_va_card', student: @student
    - if @student.wei_registration.count > 0
      #wei_card.m-t-1= render 'wei_registration', student: @student